package applicationcache

// AUTOGENERATED. DO NOT EDIT.

import (
	. "github.com/knq/chromedp/cdp"
)

var (
	_ BackendNode
	_ BackendNodeID
	_ ComputedProperty
	_ ErrorType
	_ Frame
	_ FrameID
	_ LoaderID
	_ Message
	_ MessageError
	_ MethodType
	_ Node
	_ NodeID
	_ NodeType
	_ PseudoType
	_ RGBA
	_ ShadowRootType
	_ Timestamp
)

// ApplicationCacheResource detailed application cache resource information.
type ApplicationCacheResource struct {
	URL  string `json:"url,omitempty"`  // Resource url.
	Size int64  `json:"size,omitempty"` // Resource size.
	Type string `json:"type,omitempty"` // Resource type.
}

// ApplicationCache detailed application cache information.
type ApplicationCache struct {
	ManifestURL  string                      `json:"manifestURL,omitempty"`  // Manifest URL.
	Size         float64                     `json:"size,omitempty"`         // Application cache size.
	CreationTime float64                     `json:"creationTime,omitempty"` // Application cache creation time.
	UpdateTime   float64                     `json:"updateTime,omitempty"`   // Application cache update time.
	Resources    []*ApplicationCacheResource `json:"resources,omitempty"`    // Application cache resources.
}

// FrameWithManifest frame identifier - manifest URL pair.
type FrameWithManifest struct {
	FrameID     FrameID `json:"frameId,omitempty"`     // Frame identifier.
	ManifestURL string  `json:"manifestURL,omitempty"` // Manifest URL.
	Status      int64   `json:"status,omitempty"`      // Application cache status.
}
