package css

// AUTOGENERATED. DO NOT EDIT.

import (
	. "github.com/knq/chromedp/cdp"
)

var (
	_ BackendNode
	_ BackendNodeID
	_ ComputedProperty
	_ ErrorType
	_ Frame
	_ FrameID
	_ LoaderID
	_ Message
	_ MessageError
	_ MethodType
	_ Node
	_ NodeID
	_ NodeType
	_ PseudoType
	_ RGBA
	_ ShadowRootType
	_ Timestamp
)

// EventMediaQueryResultChanged fires whenever a MediaQuery result changes
// (for example, after a browser window has been resized.) The current
// implementation considers only viewport-dependent media features.
type EventMediaQueryResultChanged struct{}

// EventFontsUpdated fires whenever a web font gets loaded.
type EventFontsUpdated struct{}

// EventStyleSheetChanged fired whenever a stylesheet is changed as a result
// of the client operation.
type EventStyleSheetChanged struct {
	StyleSheetID StyleSheetID `json:"styleSheetId,omitempty"`
}

// EventStyleSheetAdded fired whenever an active document stylesheet is
// added.
type EventStyleSheetAdded struct {
	Header *StyleSheetHeader `json:"header,omitempty"` // Added stylesheet metainfo.
}

// EventStyleSheetRemoved fired whenever an active document stylesheet is
// removed.
type EventStyleSheetRemoved struct {
	StyleSheetID StyleSheetID `json:"styleSheetId,omitempty"` // Identifier of the removed stylesheet.
}

// EventTypes is all event types in the domain.
var EventTypes = []MethodType{
	EventCSSMediaQueryResultChanged,
	EventCSSFontsUpdated,
	EventCSSStyleSheetChanged,
	EventCSSStyleSheetAdded,
	EventCSSStyleSheetRemoved,
}
