package security

// AUTOGENERATED. DO NOT EDIT.

import (
	. "github.com/knq/chromedp/cdp"
)

var (
	_ BackendNode
	_ BackendNodeID
	_ ComputedProperty
	_ ErrorType
	_ Frame
	_ FrameID
	_ LoaderID
	_ Message
	_ MessageError
	_ MethodType
	_ Node
	_ NodeID
	_ NodeType
	_ PseudoType
	_ RGBA
	_ ShadowRootType
	_ Timestamp
)

// EventSecurityStateChanged the security state of the page changed.
type EventSecurityStateChanged struct {
	SecurityState         SecurityState               `json:"securityState,omitempty"`         // Security state.
	SchemeIsCryptographic bool                        `json:"schemeIsCryptographic,omitempty"` // True if the page was loaded over cryptographic transport such as HTTPS.
	Explanations          []*SecurityStateExplanation `json:"explanations,omitempty"`          // List of explanations for the security state. If the overall security state is `insecure` or `warning`, at least one corresponding explanation should be included.
	InsecureContentStatus *InsecureContentStatus      `json:"insecureContentStatus,omitempty"` // Information about insecure content on the page.
	Summary               string                      `json:"summary,omitempty"`               // Overrides user-visible description of the state.
}

// EventTypes is all event types in the domain.
var EventTypes = []MethodType{
	EventSecuritySecurityStateChanged,
}
